#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
@author: Adrian Malthe Frandsen
"""

import matplotlib.pyplot as plt
import matplotlib as mpl
import numpy as np
from matplotlib.ticker import MultipleLocator








########mixed_Ir_Ru#####
s1 = ['Mn-A2 conv','Mn-A2 alt','Mn-B2 conv','Mn-B2 alt', 'Mn-B2 min energy', 'Mn-B4 conv', 'Mn-B4 alt']
###########################

s=s1

a=np.linspace(0.3,1,len(s1)*2)

colors = ['r','mediumspringgreen','b','coral','m','gray','plum','olive','yellow','g','c','deeppink','crimson','salmon','peru','y','purple','brown','tomato','indigo','lightpink','r','indigo','mediumspringgreen','b','b']



########### Data here / binding energies straight from dft ############
E_OH_list = np.array([
    1.14983,
    0.77483,
    1.33548,
    1.86623,
    1.33548,
    0.87559,
    0.77522
    ])

E_O_list = np.array([
    2.23379,
    2.23379,
    3.20409,
    3.20409,
    3.20409,
    2.10662,
    2.10662
    ])

E_OOH_list = np.array([
    4.54825,
    4.00685,
    5.01549,
    4.19106,
    4.19106,
    4.39489,
    3.93958
    ])


G_OH_list = E_OH_list + 0.35
G_O_list = E_O_list + 0.05
G_OOH_list = E_OOH_list + 0.4


fig, (ax2) = plt.subplots(figsize=(6, 6), ncols=1)
lw=4
al=0.7
## IDEAL ###                                                                                           
U=0
G_O2 = 4.92 - 4 * U
G_OOH = 1.23 - 1 * U
G_O = 1.23 - 1 * U
G_OH = 1.23 - 1 * U
G_H2O = 1.23 - 1 * U
G_H2O2 = 3.54


############################
# VOLCANO
############################
G_OH = np.arange(-10,10,0.1)
ax2.plot(G_OH,G_OH,color='k',ls='-',zorder=-10)
ax2.plot(G_OH,1.72-G_OH,color='k',ls='-',zorder=-10)
ax2.plot(G_OH,3.2-G_OH,color='k',ls='-',zorder=-10)
#ax2.set_title('Yb$_2$Ir$_2$O$_7$')
ax2.axhline(1.6,color='k',ls=':',alpha=al)
ax2.axhline(1.23,color='k',ls='--',alpha=al,zorder=-10)
ax2.axhline(0.86,color='k',ls=':',alpha=al)
ax2.text(2.8,1.25,'$1.23$ eV',fontsize=11)
ax2.text(2.8,1.62,'$1.60$ eV',fontsize=11)
ax2.text(2.8,0.88,'$0.86$ eV',fontsize=11)
ax2.text(0.65,0.20,'ORR',fontsize=20,alpha=0.5)
ax2.text(1.37,2.25,'OER',fontsize=20,alpha=0.5)


U=[]
# metal G_O G_OH G_OOH min
print('%s\t\t\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s'%('Metal','G_OH','G_O','G_OOH','G4','G3','G2','G1','U','volc'))
for i in range(0,len(G_O_list)):
    print('%s\t\t\t%0.2f\t%0.2f\t%0.2f\t%0.2f\t%0.2f\t%0.2f\t%0.2f\t%0.2f\t%0.2f'%(s[i],
                                            G_OH_list[i],
                                            G_O_list[i],
                                            G_OOH_list[i],
                                            4.92-G_OOH_list[i],
                                            G_OOH_list[i]-G_O_list[i],
                                            G_O_list[i]-G_OH_list[i],
                                            G_OH_list[i],
                                            np.max(np.array([4.92-G_OOH_list[i],G_OOH_list[i]-G_O_list[i],G_O_list[i]-G_OH_list[i],G_OH_list[i]])),
                                            1.72-G_OH_list[i]
                                        ))
    U.append(np.max(np.array([4.92-G_OOH_list[i],G_OOH_list[i]-G_O_list[i],G_O_list[i]-G_OH_list[i],G_OH_list[i]])))

ms=120
al=0.7
mark='o'
mark1='s'


for i in range(len(G_O_list))[:30]:
    ax2.scatter(G_O_list[i]-G_OH_list[i],U[i],color=colors[i],s=ms,edgecolor='k',marker=mark,label=r'%s'%s[i],alpha=al,zorder=1)

ax2.scatter(1.23,1.23, marker = (5,1),s=ms+50,edgecolor='k',color='yellow', label='Ideal catalyst')
ax2.scatter(1.6,1.6, marker = (5,1),s=ms+50,edgecolor='k',color='red', label='Optimal catalyst')


ax2.text(0.3,0.33, r'$\rm \Delta G$$_{1,2}$', fontsize=12,bbox=dict(facecolor='white', edgecolor='none', boxstyle='round,pad=0.2'),rotation=45)
ax2.text(1.1,0.4, r'$\rm \Delta G$$_4$', fontsize=12,bbox=dict(facecolor='white', edgecolor='none', boxstyle='round,pad=0.2'),rotation=-45)
ax2.text(2.54,0.44, r'$\rm \Delta G$$_3$', fontsize=12,bbox=dict(facecolor='white', edgecolor='none', boxstyle='round,pad=0.2'),rotation=-45)


ax2.annotate(text='', xy=(2.3,1.23), xytext=(2.3,2.3), arrowprops=dict(arrowstyle='<->'))
ax2.text(2.3,1.8,r'$\eta$$_{\rm OER}$',fontsize=14,rotation=-90)







# Print text atop the figure


ax2.set_xlabel(r'G$_{\rm O*}-$G$_{\rm HO*}$ [eV]',fontsize=14)
ax2.set_ylabel('U [V]',fontsize=14)
ax2.legend(loc=1,ncol=1,bbox_to_anchor = [1,1],fontsize=8.3,scatterpoints=1, framealpha = 1)
ax2.set_xlim([0,3.2])
ax2.set_ylim([0,3])
ax2.yaxis.set_minor_locator(MultipleLocator(0.25))
ax2.xaxis.set_minor_locator(MultipleLocator(0.25))

fig.savefig('volcano.png')




## OER-only volcano


def ov_pot(x):
    return -(x - 1.23)

G_OH = np.arange(-10,10,0.1)


fig = plt.figure()
plt.plot(G_OH,ov_pot(G_OH),color='blue',ls='-',zorder=-10)
#plt.plot(G_OH,ov_pot(1.72-G_OH),color='k',ls='-',zorder=-10)
plt.plot(G_OH,ov_pot(3.2-G_OH),color='red',ls='-',zorder=-10)

plt.scatter(1.24,-0.55,color=colors[-4],s=ms,edgecolor='k',marker=mark,alpha=al,zorder=1,label='IrO$_2$ (110)')

for i in range(len(G_O_list))[:30]:
    eta = -(U[i]-1.23)
    plt.scatter(G_O_list[i]-G_OH_list[i],eta,color=colors[i],s=ms,edgecolor='k',marker=mark,label=r'%s'%s[i],alpha=al,zorder=1)

plt.title('OER Volcanoplot')
plt.xlabel(r'G$_{\rm O*}-$G$_{\rm HO*}$ [eV]', fontsize = 14)
plt.ylabel("$-\eta$ [V]", fontsize = 14)
plt.xlim([1,2])
plt.ylim([-1.2,-0.2])
plt.legend()

fig.savefig('MnVolcano.png')


####################################################################################


# Free energy diagrams


fig, ax = plt.subplots(figsize=(8, 6), ncols=1)

#fig = plt.figure(figsize = (7,6))
#ax = fig.add_subplot(1,1,1)


lw=4
al=0.7

## IDEAL ###                                                                                           
U=0
G_O2 = 4.92 - 4 * U
G_OOH = 1.23 - 1 * U
G_O = 1.23 - 1 * U
G_OH = 1.23 - 1 * U
G_H2O = 1.23 - 1 * U



#### Free energy diagram 

ax.plot((0,0.9),(0,0),color='k',ls='-',linewidth=lw)
ax.plot([0.9,1.1],[0,G_OH], ls='--',color='k',alpha=al)
ax.plot([1.1,1.9], [G_OH,G_OH], 'k--',linewidth=1,label='Ideal OER',alpha=al)
ax.plot([1.9,2.1],[G_OH,G_OH+G_O], ls='--',color='k',alpha=al)
ax.plot([2.1,2.9], [G_OH+G_O,G_OH+G_O], 'k--',linewidth=1,alpha=al)
ax.plot([2.9,3.1],[G_OH+G_O,G_OH+G_O+G_OOH], ls='--',color='k',alpha=al)
ax.plot([3.1,3.9], [G_OH+G_O+G_OOH,G_OH+G_O+G_OOH], 'k--',linewidth=1,alpha=al)
ax.plot([3.9,4.1],[G_OH+G_O+G_OOH,G_OH+G_O+G_OOH+G_H2O], ls='--',color='k',alpha=al)
ax.plot([4.1,5], [G_OH+G_O+G_OOH+G_H2O,G_OH+G_O+G_OOH+G_H2O], 'k-',linewidth=3,alpha=al)
#############

# Plot data for the different plateaus

for i in list(range(len(E_OH_list[0:30]))):
    a = G_OOH_list[i]; b = G_O_list[i]; c = G_OH_list[i];
    U=0.0
    G_O2 = 4.92 - U
    G_OOH = a - U
    G_O = b - U
    G_OH = c - U
    G_H2O = G_O2 - G_OOH - G_O - G_OH - U
    col=colors[i]

    ax.plot((0,0.9),(0,0),color='k',ls='-',linewidth=lw)
    ax.plot([0.9,1.1],[0,G_OH], ls=':',color=col)
    ax.plot([1.1,1.9], [G_OH,G_OH], ls='-',color=col,linewidth=3,label=r'%s'%s[i])
    ax.plot([1.9,2.1],[G_OH,G_O], ls=':',color=col)
    ax.plot([2.1,2.9], [G_O,G_O], ls='-',color=col,linewidth=3,)
    ax.plot([2.9,3.1],[G_O,G_OOH], ls=':',color=col)
    ax.plot([3.1,3.9], [G_OOH,G_OOH], ls='-',color=col,linewidth=3)
    ax.plot([3.9,4.1],[G_OOH,G_O2], ls=':',color=col)
    ax.plot([4.1,5], [G_O2,G_O2], ls='-',color='k',linewidth=3,)

    
##########
ax.annotate("",
               xy=(4.5, 0),
               xytext=(4.5, 4.92),
                      arrowprops=dict(arrowstyle='<->',
                               color="k",
                               lw=1.5,
                               connectionstyle='arc3',
                               zorder = 11
                               ),
                      )

ax.text(4.5,2.5,'4.92 eV',
            fontsize=12,
            verticalalignment='bottom',
            horizontalalignment='center',
            bbox={'facecolor':'w', 'alpha':1, 'pad':0.4, 'ec':'w', 'lw':6},
            zorder=12)




ax.axhline(0,color='k',ls=':',alpha=al,zorder=-1)
ax.axhline(4.92,color='k',ls=':',alpha=al,zorder=-1)

# Print text atop the figure
hh=5.5
r=45
ax.text(0.4,hh,'*+H$_2$O',rotation=r)
ax.text(1.4,hh,'*OH',rotation=r)
ax.text(2.4,hh,'*O',rotation=r)
ax.text(3.4,hh,'*OOH',rotation=r)
ax.text(4.4,hh,r'*+O$_2$',rotation=r)


ax.set_xlabel('Reaction Coordinate',fontsize=14)
ax.set_ylabel('Free energy [eV]',fontsize=14)


ax.set_xlim([0,5])
ax.xaxis.set_ticks([])
ymin=0
ymax=6
ax.set_ylim([ymin,ymax])
ax.yaxis.set_ticks(np.arange(ymin,ymax,1))
ax.yaxis.set_minor_locator(MultipleLocator(0.25))
ax.legend(loc=4,ncol=1,fontsize=8.3,scatterpoints=1)

plt.savefig('freeenergydiagram.png')


































